# depends on first lines of Exp_1
N_2<-dim(ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),])[1]

# with 2nd data only:
res_E2_gm_Test2_drc<-drm(log10(I)~E2, fct=LL.3(fixed=c(NA, NA, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
modelFit(res_E2_gm_Test2_drc)# 0.1254  Hill with 0 min OK for E2
res_E2_gm_Test2_drc_min<-drm(log10(I)~E2, fct=LL.4(fixed=c(NA,NA, NA, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
modelFit(res_E2_gm_Test2_drc_min)#  0.7738 HIll OK
anova(res_E2_gm_Test2_drc_min, res_E2_gm_Test2_drc) # 0.0428 nearly no diff


res_Gen_gm_Test2_drc<-drm(log10(I)~Genistein, fct=LL.3(fixed=c(NA, NA, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
modelFit(res_Gen_gm_Test2_drc)# 0.178  Hill OK again for Genistein
res_Gen_gm_Test2_drc_min<-drm(log10(I)~Genistein, fct=LL.4(fixed=c(NA,NA, NA, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
modelFit(res_Gen_gm_Test2_drc_min)# 0.5558 Hill OK
anova(res_Gen_gm_Test2_drc_min, res_Gen_gm_Test2_drc) # 0.0770 no diff

# no need to fit a min!
res_ray1_gm_Test2_drc<-drm(log10(I)~Genistein, fct=LL.3(), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(6:10))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
modelFit(res_ray1_gm_Test2_drc)# Hill OK  p=  0.1006
res_ray2_gm_Test2_drc<-drm(log10(I)~Genistein, fct=LL.3(), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(11:15))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
modelFit(res_ray2_gm_Test2_drc)# Hill OK  p= 0.000
modelFit(drm(log10(I)~Genistein, fct=LL.4(), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(11:15))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])) # 0.0941
res_ray3_gm_Test2_drc<-drm(log10(I)~Genistein, fct=LL.3(), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(16:20))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
modelFit(res_ray3_gm_Test2_drc)# Hill OK  p=  0.0464








# with estimated min
res_E2_gm_Test2_min<-drm(log10(I)~E2, fct=LL.4(), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])

res_Gen_gm_Test2_min<-drm(log10(I)~Genistein, fct=LL.4(), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])

common_min_max_mixture_gm_Test2<-optim(par=c(-0.2, 0.8), fn=function(x) sum(drm(log10(I)~E2, fct=LL.4(fixed=c(NA, x[1], x[2], NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])$fit$value, drm(log10(I)~Genistein, fct=LL.4(fixed=c(NA, x[1], x[2], NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])$fit$value))$par
#-0.1577488  1.0019073
res_E2_gm_common_min_max_Test2<-drm(log10(I)~E2, fct=LL.4(fixed=c(NA, common_min_max_mixture_gm_Test2, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
# pente, EC
# 1.293478039 0.000420208
res_Gen_gm_common_min_max_Test2<-drm(log10(I)~Genistein, fct=LL.4(fixed=c(NA, common_min_max_mixture_gm_Test2, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
# 2.4561851 0.6384305 #  pente moins forte qu'avec min=0.

F_value_fixed_min_max_mixture_E2_gm_Test2<-(res_E2_gm_common_min_max_Test2$fit$value-res_E2_gm_Test2_min$fit$value)/2/res_E2_gm_Test2_min$fit$value*(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-4)
pf_value_fixed_min_max_mixture_E2_gm_Test2<-1-pf(rev(F_value_fixed_min_max_mixture_E2_gm_Test2)[1],2,(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-4))
#  0.9698492
F_value_fixed_min_max_mixture_Gen_gm_Test2<-(res_Gen_gm_common_min_max_Test2$fit$value-res_Gen_gm_Test2_min$fit$value)/2/res_Gen_gm_Test2_min$fit$value*(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-4)
pf_value_fixed_min_max_mixture_Gen_gm_Test2<-1-pf(rev(F_value_fixed_min_max_mixture_Gen_gm_Test2)[1],2,(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-4))
# 0.9869104
# le max et min commun conviennent
# [...]
list_res_ray_gm_Test2_min<-lapply(list_ray, function(x) CA_complete2_Min(C_mat=x, Min=common_min_max_mixture_gm_Test2[1], Max=common_min_max_mixture_gm_Test2[2], Slopes=c(-res_E2_gm_common_min_max_Test2$res$par[1], -res_Gen_gm_common_min_max_Test2$res$par[1]), Ec50s=c(res_E2_gm_common_min_max_Test2$res$par[2], res_Gen_gm_common_min_max_Test2$res$par[2])))


# est-ce que la pente commune convient? (min et max, pente que sur E2 et Gén....)
common_slope_mixture_gm_Test2<-optimize(f=function(x) sum(drm(log10(I)~E2, fct=LL.4(fixed=c(x, common_min_max_mixture_gm_Test2, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])$fit$value, drm(log10(I)~Genistein, fct=LL.4(fixed=c(x, common_min_max_mixture_gm_Test2, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])$fit$value), interval=c(-3,-1))$minimum
#  EC 1.898626 ne change pas la pente par rapport à l'utilisation de la moyenne arithmétique
res_E2_gm_common_min_max_slope_Test2<-drm(log10(I)~E2, fct=LL.4(fixed=c(common_slope_mixture_gm_Test2, common_min_max_mixture_gm_Test2, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
# pente, EC
#0.000413413
res_Gen_gm_common_min_max_slope_Test2<-drm(log10(I)~Genistein, fct=LL.4(fixed=c(common_slope_mixture_gm_Test2, common_min_max_mixture_gm_Test2, NA)), data=ZGM_mixture_E2_Gen_gm_relative[which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")),])
# EC 0.6487521

F_value_fixed_min_max_slope_mixture_E2_gm_Test2<-(res_E2_common_min_max_slope_Test2$fit$value-res_E2_gm_Test2_min$fit$value)/1/res_E2_gm_Test2_min$fit$value*(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-4)
pf_value_fixed_min_max_slope_mixture_E2_gm_Test2<-1-pf(rev(F_value_fixed_min_max_slope_mixture_E2_gm_Test2)[1],1,(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-4))
#   0.1066011
F_value_fixed_min_max_slope_mixture_Gen_gm_Test2<-(res_Gen_gm_common_min_max_slope_Test2$fit$value-res_Gen_gm_Test2_min$fit$value)/1/res_Gen_gm_Test2_min$fit$value*(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-4)
pf_value_fixed_min_max_slope_mixture_Gen_gm_Test2<-1-pf(rev(F_value_fixed_min_max_slope_mixture_Gen_gm_Test2)[1],1,(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-4))
# 0.2635032
# la pente commune convient globalement.

F_value_fixed_min_max_slope_mixture_E2_gm_Test2_2<-(res_E2_gm_common_min_max_slope_Test2$fit$value-res_E2_gm_common_min_max_Test2$fit$value)/1/res_E2_common_min_max_Test2$fit$value*(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-2)
pf_value_fixed_min_max_slope_mixture_E2_gm_Test2_2<-1-pf(rev(F_value_fixed_min_max_slope_mixture_E2_gm_Test2_2)[1],1,(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-2))
#  0.1052129
F_value_fixed_min_max_slope_mixture_Gen_gm_Test2_2<-(res_Gen_gm_common_min_max_slope_Test2$fit$value-res_Gen_gm_common_min_max_Test2$fit$value)/1/res_Gen_gm_common_min_max_Test2$fit$value*(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-2)
pf_value_fixed_min_max_slope_mixture_Gen_gm_Test2_2<-1-pf(rev(F_value_fixed_min_max_slope_mixture_Gen_gm_Test2_2)[1],1,(length(which((ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))&(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")))-1-2))
# 0.2613713
# le pente commune convient quand on compare à min et max communs


# pourquoi j'ai utilisé  CA_complete2_Min pas le modifié? parce que pas d'interaction.


jpeg("Zebra_GM/E2_Gen_gm/ZGM_mixture_E2_Gen_gm_relative_CA_min.jpg", width=20, height=5, unit="cm", pointsize=6, res=300)
par(mfrow=c(1,5), mar=c(4,4,2,0.5), cex.axis=1.2, cex.lab=1.2, cex.main=1.5, mgp=c(2.5,1.2,0))
plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),1]*1000, log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),4]), type="l", log="x", col=1, lty=1, ylab="log10 fold induction", xlab="Concentration (nM)", main="E2", xlim=c(10^(-2), 5), ylim=c(-1.4,1.7))
points(ray_E2[,1]*1000, list_res_ray[[1]], type="l", lwd=2)
points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),1]*1000, log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),5]), type="l", col=2, lty=1)
points(ray_E2[,1]*1000, list_res_ray_gm_Test2_min[[1]], type="l", lwd=2, col=2)
points(ZGM_mixture_E2_Gen_gm_relative$E2[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))]*1000, log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))]), col=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))]), pch=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(1:5))]))
abline(h=0)
legend("topleft", col=1, lty=1, lwd=c(1, 2), legend=c("data", "CA model"), ncol=2)
par(mar=c(4,2,2,0.5))

plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(6:10)),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(6:10)),2]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(6:10)),4]), type="l", log="x", col=1, lty=1, ylab="log10 fold induction", xlab="Concentration eq E2 (nM)", main="E2:Gen 3:1", xlim=c(10^(-2), 5), ylim=c(-1.4,1.7))
points(ray_3E2_Gen[,1]*1000+ray_3E2_Gen[,2]*1000/mean_EC50[3]*mean_EC50[1], list_res_ray[[2]], type="l", lwd=2)
points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(6:10)),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(6:10)),2]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(6:10)),5]), type="l", col=2, lty=1)
points(ray_3E2_Gen[,1]*1000+ray_3E2_Gen[,2]*1000/mean_EC50[3]*mean_EC50[1], list_res_ray_gm_Test2_min[[2]], type="l", lwd=2, col=2)
points(ZGM_mixture_E2_Gen_gm_relative$E2[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(6:10))]*1000+ZGM_mixture_E2_Gen_gm_relative$Genistein[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(6:10))]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(6:10))]), col=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(6:10))]), pch=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(6:10))]))
legend("topleft", col=1, lty=1, lwd=c(1, 2), legend=c("data", "CA model"), ncol=2)
abline(h=0)

plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(11:15)),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(11:15)),2]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(11:15)),4]), type="l", log="x", col=1, lty=1, ylab="log10 fold induction", xlab="Concentration en E2 (nM)", main="E2:Gen 1:1", xlim=c(10^(-2), 5), ylim=c(-1.4,1.7))
points(ray_E2_Gen_gm[,1]*1000+ray_E2_Gen_gm[,2]*1000/mean_EC50[3]*mean_EC50[1], list_res_ray[[3]], type="l", lwd=2)
points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(11:15)),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(11:15)),2]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(11:15)),5]), type="l", col=2, lty=1)
points(ray_E2_Gen_gm[,1]*1000+ray_E2_Gen_gm[,2]*1000/mean_EC50[3]*mean_EC50[1], list_res_ray_gm_Test2_min[[3]], type="l", lwd=2, col=2)
points(ZGM_mixture_E2_Gen_gm_relative$E2[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(11:15))]*1000+ZGM_mixture_E2_Gen_gm_relative$Genistein[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(11:15))]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(11:15))]), col=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(11:15))]), pch=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(11:15))]))
legend("topleft", col=1, lty=1, lwd=c(1, 2), legend=c("data", "CA model"), ncol=2)
abline(h=0)

plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(16:20)),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(16:20)),2]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(16:20)),4]), type="l", log="x", col=1, lty=1, ylab="log10 fold induction", xlab="Concentration eq E2 (nM)", main="E2:Gen 1:3", xlim=c(10^(-2), 5), ylim=c(-1.4,1.7))
points(ray_E2_3Gen[,1]*1000+ray_E2_3Gen[,2]*1000/mean_EC50[3]*mean_EC50[1], list_res_ray[[4]], type="l", lwd=2)
points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(16:20)),1]+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(16:20)),2]/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(16:20)),5]), type="l", col=2, lty=1)
points(ray_E2_3Gen[,1]*1000+ray_E2_3Gen[,2]*1000/mean_EC50[3]*mean_EC50[1], list_res_ray_gm_Test2_min[[4]], type="l", lwd=2, col=2)
points(ZGM_mixture_E2_Gen_gm_relative$E2[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(16:20))]*1000+ZGM_mixture_E2_Gen_gm_relative$Genistein[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(16:20))]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(16:20))]), col=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(16:20))]), pch=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(16:20))]))
legend("topleft", col=1, lty=1, lwd=c(1, 2), legend=c("data", "CA model"), ncol=2)
abline(h=0)

plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(21:25)),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(21:25)),2]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(21:25)),4]), type="l", log="x", col=1, lty=1, ylab="log10 fold induction", xlab="Concentration eq E2 (nM)", main="E2:Gen 0:1", xlim=c(10^(-2), 5), ylim=c(-1.4,1.7))
points(ray_Gen[,2]*1000/mean_EC50[3]*mean_EC50[1], list_res_ray[[5]], type="l", lwd=2)
points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(21:25)),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(21:25)),2]/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(21:25)),5]), type="l", col=2, lty=1)
points(ray_Gen[,2]*1000/mean_EC50[3]*mean_EC50[1], list_res_ray_gm_Test2_min[[5]], type="l", lwd=2, col=2)
points(ZGM_mixture_E2_Gen_gm_relative$E2[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))]*1000+ZGM_mixture_E2_Gen_gm_relative$Genistein[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))]*1000/mean_EC50[3]*mean_EC50[1], log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))]), col=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))]), pch=as.numeric(ZGM_mixture_E2_Gen_gm_relative$essai[which(ZGM_mixture_E2_Gen_gm_relative$Num%in%c(21:25))]))
legend("topleft", col=1, lty=1, lwd=c(1, 2), legend=c("data", "CA model"), ncol=2)
abline(h=0)
dev.off()
# can possibly see an antagonism again

jpeg("Zebra_GM/E2_Gen_gm/ZGM_mixture_E2_Gen_gm_relative_all_essay2_model_CA_newTEF.jpg", width=8, height=8, unit="cm", pointsize=8, res=300)
par(mar=c(4,4,3.5,1), cex.axis=1.2, cex.lab=1.2, cex.main=1.5, mgp=c(2.5,1.2,0))
plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),1]*1000, log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),5]), type="p", log="x", col=1, pch=1, ylab="log10 fold induction", xlab="Concentration eq E2 (nM)", xlim=c(1.93*10^(-2), 5), ylim=c(-0.4,1.2))
points(list_ray[[1]][,1]*1000+list_ray[[1]][,2]*1000/res_Gen_gm_common_min_max_Test2$res$par[2]*res_E2_common_min_max_Test2$res$par[2], list_res_ray_gm_Test2_min[[1]], type="l", lwd=2)
abline(h=0)
title("Concentration Addition predictions")
for (i in 2:5){
  points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),2]*1000/res_Gen_gm_common_min_max_Test2$res$par[2]*res_E2_common_min_max_Test2$res$par[2], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),5]), type="p", col=i, pch=i)
  points(list_ray[[i]][,1]*1000+list_ray[[i]][,2]*1000/res_Gen_gm_common_min_max_Test2$res$par[2]*res_E2_common_min_max_Test2$res$par[2], list_res_ray_gm_Test2_min[[i]], type="l", lwd=2, col=i, lty=i)
}
legend("topleft", col=c(1:5), lty=c(1:5), lwd=1, pch=c(1:5), legend=c("E2","E2:Gen 3:1", "E2:Gen 1:1","E2:Gen 1:3", "Gen"), ncol=1)
dev.off() 

list_res_ray_IA_Test2_gm_min<-lapply(list_ray, function(x) IA_Min(C_mat=x, Min=common_min_max_mixture_gm_Test2[1], Max=common_min_max_mixture_gm_Test2[2], Slopes=c(-res_E2_gm_common_min_max_Test2$res$par[1], -res_Gen_gm_common_min_max_Test2$res$par[1]), Ec50s=c(res_E2_gm_common_min_max_Test2$res$par[2], res_Gen_gm_common_min_max_Test2$res$par[2])))

jpeg("Zebra_GM/E2_Gen_gm/ZGM_mixture_E2_Gen_gm_relative_all_essay2_model_IA_newTEF.jpg", width=8, height=8, unit="cm", pointsize=8, res=300)
par(mar=c(4,4,3.5,1), cex.axis=1.2, cex.lab=1.2, cex.main=1.5, mgp=c(2.5,1.2,0))
plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),1]*1000, log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),5]), type="p", log="x", col=1, pch=1, ylab="log10 fold induction", xlab="Concentration eq E2 (nM)", xlim=c(1.93*10^(-2), 5), ylim=c(-0.4,1.2))
points(list_ray[[1]][,1]*1000+list_ray[[1]][,2]*1000/res_Gen_gm_common_min_max_Test2$res$par[2]*res_E2_common_min_max_Test2$res$par[2], list_res_ray_IA_Test2_gm_min[[1]], type="l", lwd=2)
abline(h=0)
title("Independent Action predictions")
for (i in 2:5){
  points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),2]*1000/res_Gen_gm_common_min_max_Test2$res$par[2]*res_E2_gm_common_min_max_Test2$res$par[2], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),5]), type="p", col=i, pch=i)
  points(list_ray[[i]][,1]*1000+list_ray[[i]][,2]*1000/res_Gen_gm_common_min_max_Test2$res$par[2]*res_E2_gm_common_min_max_Test2$res$par[2], list_res_ray_IA_Test2_gm_min[[i]], type="l", lwd=2, col=i, lty=i)
}
legend("topleft", col=c(1:5), lty=c(1:5), lwd=1, pch=c(1:5), legend=c("E2","E2:Gen 3:1", "E2:Gen 1:1","E2:Gen 1:3", "Gen"), ncol=1)
dev.off()

res_E2_Gen_gm_fit_Test2_min<-CA_complete2_fit_Min_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.5,-0.5,-0.5, 0.001, 2), lower=c(-0.5,0.5,-5,-5,0.0001,0.1), start=c(-0.3,1,-2,-2,0.0005,1)) 
# $Min -0.1388906
# $Max 1.043786
# $Slopes -1.532961 -2.689746
# $Ec50s 0.0004627678 0.8210936704
# $a 1.236097
# $RSS 32.3785

res_E2_Gen_gm_fit_SA_Test2_min_nlm<-CA_complete2_fit_Min_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.2,-0.5,-1, 0.001, 1.5,5), lower=c(-0.5,0.7,-3,-4,0.0001,0.2,-1), start=c(-0.2,1,-1,-2,0.0005,1,0), interact="SA") # 
# $Min -0.1423161
# $Max 1.043315
# $Slopes -1.457515 -2.566695
# $Ec50s 0.0004597733 0.7923063621
# $a 1.440805
# $RSS 32.27621
res_E2_Gen_gm_fit_DR_Test2_min_nlm<-CA_complete2_fit_Min_speed(C_mat=as.matrix(ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4]), Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.2,-0.5,-1, 0.001, 1.5,5,5), lower=c(-0.5,0.7,-3,-4,0.0001,0.2,-5,-5), start=c(-0.2,1,-1,-2,0.0005,1,0,0), interact="DR") #
# $Min -0.1422106
# $Max 1.039542
# $Slopes -1.516042 -2.689272
# $Ec50s 0.0004721246 0.7383410917
# $a 3.071523
# $b -4.334392
# $RSS 32.23173
res_E2_Gen_gm_fit_DL_Test2_min_newDL_nlm<-CA_complete2_fit_Min_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.2,-0.5,-1, 0.001, 1.5,15,7), lower=c(-0.5,0.7,-3,-4,0.0001,0.2,0,-2), start=c(-0.2,1,-1,-2,0.0005,1,2,0), interact="DL", multicore=FALSE, mc.cores=15)
# $Min -0.1395043
# $Max 1.04205
# $Slopes -1.534230 -2.697555
# $Ec50s 0.0004617733 0.8186471229
# $a 1.214668
# $b -0.2151969
# $RSS 32.37818

res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm<-CA_complete2_fit_Min_modified_nlm_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.2,-0.5,-1, 0.001, 1.5,5), lower=c(-0.5,0.7,-3,-4,0.0001,0.2,-1), start=c(-0.2,1,-1,-2,0.0005,1,0), interact="SA", multicore=FALSE, mc.cores=15) # 
# $Min -0.1423161
# $Max 1.043315
# $Slopes -1.457515 -2.566695
# $Ec50s 0.0004597733 0.7923063621
# $a 1.440805
# $RSS 32.27621
res_E2_Gen_gm_fit_modified_DR_Test2_min_nlm<-CA_complete2_fit_Min_modified_nlm_speed(C_mat=as.matrix(ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4]), Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.2,-0.5,-1, 0.001, 1.5,5,5), lower=c(-0.5,0.7,-3,-4,0.0001,0.2,-5,-5), start=c(-0.2,1,-1,-2,0.0005,1,0,0), interact="DR", iter=500, multicore=FALSE, mc.cores=15) #
# $Min -0.142554
# $Max 1.040334
# $Slopes -1.549928 -2.558381
# $Ec50s 0.0004631054 0.7525012117
# $a 2.458369
# $b -2.441601
# $RSS 32.24794
res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm<-CA_complete2_fit_Min_modified_nlm_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.2,-0.5,-1, 0.001, 1.5,15,7), lower=c(-0.5,0.7,-3,-4,0.0001,0.2,0,-2), start=c(-0.2,1,-1,-2,0.0005,1,2,0), interact="DL", multicore=FALSE, mc.cores=15) #
# $Min -0.1486629
# $Max 1.036647
# $Slopes -1.224929 -2.104274
# $Ec50s 0.0004275115 0.7880909241
# $a 5.711386
# $b 0.6074685
# $RSS 32.0029
# carrément mieux, mais je ne comprends pas pourquoi j'ai des paramètres d'interaction qui ont tant changé.

res_E2_Gen_gm_fit_Test2_min_idslopes<-CA_complete2_fit_Min_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.5,-0.5, 0.001, 2), lower=c(-0.5,0.5,-5,0.0001,0.1), start=c(-0.3,1,-2,0.0005,1), identical_slopes=TRUE) 
# $Min -0.1272632
# $Max 1.035985
# $Slopes -2.356413 -2.356413
# $Ec50s 0.0005098886 0.9329416762
# $RSS 33.14313
res_E2_Gen_gm_fit_SA_Test2_min_idslopes<-CA_complete2_fit_Min_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.5,-0.5, 0.001, 2,4), lower=c(-0.5,0.5,-5,0.0001,0.1,-4), start=c(-0.3,1,-2,0.0005,1,0), interact="SA", identical_slopes=TRUE) 
# $Min -0.1325532
# $Max 1.022627
# $Slopes -2.454932 -2.454932
# $Ec50s 0.0003929529 0.7892971498
# $a 1.364454
# $RSS 32.71248
res_E2_Gen_gm_fit_DR_Test2_min_idslopes<-CA_complete2_fit_Min_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.5,-0.5, 0.001, 2,10,10), lower=c(-0.5,0.5,-5,0.0001,0.1,-10,-10), start=c(-0.3,1,-2,0.0005,1,0,0), interact="DR", identical_slopes=TRUE) #
# $Min -0.1368167
# $Max 1.018084
# $Slopes -2.504146 -2.504146
# $Ec50s 0.0003998439 0.7185673820
# $a 2.96479
# $b -3.569568
# $RSS 32.60626

res_E2_Gen_gm_fit_DL_Test2_min_idslopes<-CA_complete2_fit_Min_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(0,1.5,-0.5, 0.001, 2,10,10), lower=c(-0.5,0.5,-5,0.0001,0.1,-10,-10), start=c(-0.3,1,-2,0.0005,1,0,0), interact="DL", identical_slopes=TRUE) #
# $Min -0.1392358
# $Max 1.018143
# $Slopes -1.953174 -1.953174
# $Ec50s 0.0003916638 0.7932730346
# $a 4.99161
# $b 0.5875296
# $RSS 32.52295

list_models_Test2_gm<-list(CA=res_E2_Gen_gm_fit_Test2_min, CA_idslopes=res_E2_Gen_gm_fit_Test2_min_idslopes, SA_idslopes=res_E2_Gen_gm_fit_SA_Test2_min_idslopes, DR_idslopes=res_E2_Gen_gm_fit_DR_Test2_min_idslopes, DL_idslopes=res_E2_Gen_gm_fit_DL_Test2_min_idslopes, SA=res_E2_Gen_gm_fit_SA_Test2_min_nlm, DR=res_E2_Gen_gm_fit_DR_Test2_min_nlm, DL=res_E2_Gen_gm_fit_DL_Test2_min_newDL_nlm, SA_modified=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, DR_modified=res_E2_Gen_gm_fit_modified_DR_Test2_min_nlm, DL_modified=res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm)#, Sorensen_SA=res_E2_Gen_gm_fit_Sorensen_SA_Test2_min, Sorensen_strong=res_E2_Gen_gm_fit_Sorensen_strong_Test2_min, Sorensen_asym=res_E2_Gen_gm_fit_Sorensen_asym_Test2_min)
unlist(lapply(list_models_Test2_gm, function(x) x$RSS))
res_aov_ZGM_E2_Gen_Test2<-aov(log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")])~as.factor(ZGM_mixture_E2_Gen_gm_relative$Num[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), data=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),])

modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_Test2_min_idslopes, 5)$p # 0.005172612 
modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_Test2_min, 6)$p # 0.01594753
modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 7)$p # 0.03222121
modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm, 8)$p # 0.0500857
model_comp(res_E2_Gen_gm_fit_Test2_min, res_E2_Gen_gm_fit_Test2_min_idslopes, 6,5,N_2)$p # 0.01877435
model_comp(res_E2_Gen_gm_fit_SA_Test2_min_idslopes, res_E2_Gen_gm_fit_Test2_min_idslopes, 6,5,N_2)$p #  0.02967533
model_comp(res_E2_Gen_gm_fit_DL_Test2_min_idslopes, res_E2_Gen_gm_fit_SA_Test2_min_idslopes, 7,6,N_2)$p #  0.1478093
model_comp(res_E2_Gen_gm_fit_DR_Test2_min_idslopes, res_E2_Gen_gm_fit_SA_Test2_min_idslopes, 7,6,N_2)$p #  0.2788839
model_comp(res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, res_E2_Gen_gm_fit_Test2_min, 7,6,N_2)$p #  0.04422573
model_comp(res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 8,7,N_2)$p #   0.08037944
model_comp(res_E2_Gen_gm_fit_modified_DR_Test2_min_nlm, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 8,7,N_2)$p #   0.5745772

model_comp(res_E2_Gen_gm_fit_SA_Test2_min_nlm, res_E2_Gen_gm_fit_Test2_min, 7,6,N_2)$p #  0.08818014
model_comp(res_E2_Gen_gm_fit_DL_Test2_min_newDL_nlm, res_E2_Gen_gm_fit_SA_Test2_min_nlm, 8,7,N_2)$p #   0.9527695
model_comp(res_E2_Gen_gm_fit_DR_Test2_min_nlm, res_E2_Gen_gm_fit_SA_Test2_min_nlm, 8,7,N_2)$p #    0.2012435


# do we need a min not equal to 0?

res_E2_Gen_gm_fit_Test2<-CA_complete2_fit_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(1.5,-0.5,-0.5, 0.001, 2), lower=c(0.5,-5,-5,0.0001,0.1), start=c(1,-2,-2,0.0005,1)) 
# $Max 1.018587
# $Slopes -1.942659 -4.778240
# $Ec50s 0.0005990698 1.1156238461
# $RSS 34.61761

res_E2_Gen_gm_fit_SA_Test2_nlm<-CA_complete2_fit_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(1.2,-0.5,-1, 0.001, 1.5,5), lower=c(0.7,-3,-4,0.0001,0.2,-1), start=c(1,-1,-2,0.0005,1,0), interact="SA") # 
# $Max 1.025115
# $Slopes -1.930997 -3.744535
# $Ec50s 0.0005780058 1.0190113313
# $a 0.5605204
# $RSS 34.59807
res_E2_Gen_gm_fit_DR_Test2_nlm<-CA_complete2_fit_speed(C_mat=as.matrix(ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4]), Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(1.2,-0.5,-1, 0.001, 1.5,5,5), lower=c(0.7,-3,-4,0.0001,0.2,-5,-5), start=c(1,-1,-2,0.0005,1,0,0), interact="DR") #
# $Max 1.023602
# $Slopes -1.928895 -3.776489
# $Ec50s 0.0005838125 0.9793386711
# $a 1.218532
# $b -1.639846
# $RSS 34.57423

res_E2_Gen_gm_fit_DL_Test2_newDL_nlm<-CA_complete2_fit_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(1.2,-0.5,-1, 0.001, 1.5,15,7), lower=c(0.7,-3,-4,0.0001,0.2,0,-2), start=c(1,-1,-2,0.0005,1,2,0), interact="DL")
# $Max 1.025615
# $Slopes -1.952407 -3.987695
# $Ec50s 0.0006322478 1.0830391725
# $a 0.0001313984
# $b -1.289744
# $RSS 34.63629

res_E2_Gen_gm_fit_modified_SA_Test2_nlm<-CA_complete2_fit_modified_nlm_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(1.2,-0.5,-1, 0.001, 1.5,5), lower=c(0.7,-3,-4,0.0001,0.2,-1), start=c(1,-1,-2,0.0005,1,0), interact="SA") # 
# $Max 1.023357
# $Slopes -1.907526 -3.781471
# $Ec50s 0.0005813812 1.0149779495
# $a 0.5564015
# $RSS 34.58511
res_E2_Gen_gm_fit_modified_DR_Test2_nlm<-CA_complete2_fit_modified_nlm_speed(C_mat=as.matrix(ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4]), Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(1.2,-0.5,-1, 0.001, 1.5,5,5), lower=c(0.7,-3,-4,0.0001,0.2,-5,-5), start=c(1,-1,-2,0.0005,1,0,0), interact="DR") #
# $Max 1.026585
# $Slopes -1.897436 -3.584139
# $Ec50s 0.0005735813 0.9984881088
# $a 0.7033711
# $b -0.001398144
# $RSS 34.58439
res_E2_Gen_gm_fit_modified_DL_Test2_newDL_nlm<-CA_complete2_fit_modified_nlm_speed(C_mat=ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),3:4], Response=log10(ZGM_mixture_E2_Gen_gm_relative$I[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]), upper=c(1.2,-0.5,-1, 0.001, 1.5,15,7), lower=c(0.7,-3,-4,0.0001,0.2,0,-2), start=c(1,-1,-2,0.0005,1,2,0), interact="DL") #
# $Max 1.021746
# $Slopes -1.690838 -2.988108
# $Ec50s 0.0005592299 0.9745097202
# $a 3.62117
# $b 0.7810479
# $RSS 34.52281

model_comp(res_E2_Gen_gm_fit_Test2_min, res_E2_Gen_gm_fit_Test2, 6,5,N_2)$p #4.015286e-06 ajouter le min c'est beaucoup mieux 
model_comp(res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, res_E2_Gen_gm_fit_modified_SA_Test2_nlm, 6,5,N_2)$p #5.800998e-07 ajouter le min c'est beaucoup mieux pour SA.
model_comp(res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm, res_E2_Gen_gm_fit_modified_DL_Test2_newDL_nlm, 6,5,N_2)$p #1.654598e-07 ajouter le min c'est beaucoup mieux pour DL.

# yes, we did need to estimate the min


grid_E2_not_log<-seq(0,0.003, length=21)
grid_Gen_not_log<-seq(0,4, length=41)
grid_E2_Gen_gm_not_log<-expand.grid(grid_E2_not_log, grid_Gen_not_log)
grid_E2_Gen_gm_not_log<-grid_E2_Gen_gm_not_log[order(rev(grid_E2_Gen_gm_not_log$Var2)),]
contour(x=grid_E2_not_log, y=grid_Gen_not_log, z=matrix(CA_complete2_Min_modified_nlm(C_mat=grid_E2_Gen_gm_not_log, Min=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Min, Max=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Max, Slopes=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Slopes, Ec50s=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s, a=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$a, b=0, interact="DR")[order(grid_E2_Gen_gm_not_log[,2])],nrow=length(grid_E2_not_log), ncol=length(grid_Gen_not_log), byrow=FALSE), asp=mean_EC50[1]/mean_EC50[3]) # ok

jpeg("Zebra_GM/E2_Gen_gm/ZGM_mixture_E2_Gen_gm_relative_contour_model_modified_SA_Essai2.jpg", width=8, height=6, unit="cm", pointsize=7, res=300)
par(mar=c(4,4,0.5,1), cex.axis=1.2, cex.lab=1.2, cex.main=1.5, mgp=c(2.5,1.2,0))
contour(x=grid_E2_not_log*1000, y=grid_Gen_not_log*1000, z=matrix(CA_complete2_Min_modified_nlm(C_mat=grid_E2_Gen_gm_not_log, Min=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Min, Max=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Max, Slopes=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Slopes, Ec50s=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s, a=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$a, interact="SA")[order(grid_E2_Gen_gm_not_log[,2])],nrow=length(grid_E2_not_log), ncol=length(grid_Gen_not_log), byrow=FALSE), asp=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s[1]/res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s[2], xlab="E2 (nM)", ylab="Genistein (nM)")
dev.off()
list_res_ray_modified_SA_Test2_gm_min<-lapply(list_ray, function(x) CA_complete2_Min_modified_nlm(C_mat=x, Min=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Min, Max=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Max, Slopes=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Slopes, Ec50s=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s, a=res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$a, interact="SA"))

jpeg("Zebra_GM/E2_Gen_gm/ZGM_mixture_E2_Gen_gm_relative_all_essay2_model_modified_SA_newTEFF.jpg", width=8, height=8, unit="cm", pointsize=8, res=300)
par(mar=c(4,4,3.5,0.5), cex.axis=1.2, cex.lab=1.2, cex.main=1.5, mgp=c(2.5,1.2,0))
plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),1]*1000, log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),5]), type="p", log="x", col=1, pch=1, ylab="log10 fold induction", xlab="Concentration eq E2 (nM)", xlim=c(1.93*10^(-2), 5), ylim=c(-0.4,1.2))
points(list_ray[[1]][,1]*1000+list_ray[[1]][,2]*1000/res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s[2]*res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s[1], list_res_ray_modified_SA_Test2_gm_min[[1]], type="l", lwd=2)
abline(h=0)
title("Simple antagonism/synergism")
for (i in 2:5){
  points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),2]*1000/res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s[2]*res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),5]), type="p", col=i, pch=i)
  points(list_ray[[i]][,1]*1000+list_ray[[i]][,2]*1000/res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s[2]*res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$Ec50s[1], list_res_ray_modified_SA_Test2_gm_min[[i]], type="l", lwd=2, col=i, lty=i)
}
legend("topleft", col=c(1:5), lty=c(1:5), lwd=1, pch=c(1:5), legend=c("E2","E2:Gen 3:1", "E2:Gen 1:1","E2:Gen 1:3", "Gen"), ncol=1)
dev.off() 



list_res_ray_modified_DL_Test2_gm_min_nlm<-lapply(list_ray, function(x) CA_complete2_Min_modified_nlm(C_mat=x, Min=res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$Min, Max=res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$Max, Slopes=res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$Slopes, Ec50s=res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$Ec50s, a=res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$a, b=res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$b, interact="DL"))

jpeg("Zebra_GM/E2_Gen_gm/ZGM_mixture_E2_Gen_gm_relative_all_essay2_model_modified_DL_nlm_newTEFF.jpg", width=8, height=8, unit="cm", pointsize=8, res=300)
par(mar=c(4,4,3.5,0.5), cex.axis=1.2, cex.lab=1.2, cex.main=1.5, mgp=c(2.5,1.2,0))
plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),1]*1000, log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),5]), type="p", log="x", col=1, pch=1, ylab="log10 fold induction", xlab="Concentration eq E2 (nM)", xlim=c(1.93*10^(-2), 5), ylim=c(-0.4,1.2))
points(list_ray[[1]][,1]*1000, list_res_ray_modified_DL_Test2_gm_min_nlm[[1]], type="l", lwd=2)
abline(h=0)
title("DL interaction")
for (i in 2:5){
  points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),2]*1000/res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$Ec50s[2]*res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$Ec50s[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),5]), type="p", col=i, pch=i)
  points(list_ray[[i]][,1]*1000+list_ray[[i]][,2]*1000/res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$Ec50s[2]*res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$Ec50s[1], list_res_ray_modified_DL_Test2_gm_min_nlm[[i]], type="l", lwd=2, col=i, lty=i)
}
legend("topleft", col=c(1:5), lty=c(1:5), lwd=1, pch=c(1:5), legend=c("E2","E2:Gen 3:1", "E2:Gen 1:1","E2:Gen 1:3", "Gen"), ncol=1)
dev.off() 




list_res_ray_CA_Test2_gm_min<-lapply(list_ray, function(x) CA_complete2_Min(C_mat=x, Min=res_E2_Gen_gm_fit_Test2_min$Min, Max=res_E2_Gen_gm_fit_Test2_min$Max, Slopes=res_E2_Gen_gm_fit_Test2_min$Slopes, Ec50s=res_E2_Gen_gm_fit_Test2_min$Ec50s, interact="none"))


jpeg("Zebra_GM/E2_Gen_gm/ZGM_mixture_E2_Gen_gm_relative_all_essay2_model_CA_whole_newTEF.jpg", width=8, height=8, unit="cm", pointsize=8, res=300)
par(mar=c(4,4,3.5,0.5), cex.axis=1.2, cex.lab=1.2, cex.main=1.5, mgp=c(2.5,1.2,0))
plot(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),1]*1000, log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%c(1:5)),5]), type="p", log="x", col=1, pch=1, ylab="Intensité relative", xlab="Concentration eq E2", xlim=c(1.93*10^(-2), 5), ylim=c(-0.4,1.2))
points(list_ray[[1]][,1]*1000+list_ray[[1]][,2]*1000/res_E2_Gen_gm_fit_Test2_min$Ec50s[2]*res_E2_Gen_gm_fit_Test2_min$Ec50s[1], list_res_ray_CA_Test2_gm_min[[1]], type="l", lwd=2)
abline(h=0)
title("Concentration Addition")
for (i in 2:5){
  points(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),1]*1000+ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),2]*1000/res_E2_Gen_gm_fit_Test2_min$Ec50s[2]*res_E2_Gen_gm_fit_Test2_min$Ec50s[1], log10(ZGM_mixture_E2_Gen_gm_geom_mean[which(ZGM_mixture_E2_Gen_gm_geom_mean$Num%in%((5*(i-1)+1):(5*i))),5]), type="p", col=i, pch=i)
  points(list_ray[[i]][,1]*1000+list_ray[[i]][,2]*1000/res_E2_Gen_gm_fit_Test2_min$Ec50s[2]*res_E2_Gen_gm_fit_Test2_min$Ec50s[1], list_res_ray_CA_Test2_gm_min[[i]], type="l", lwd=2, col=i, lty=i)
}
legend("topleft", col=c(1:5), lty=c(1:5), lwd=1, pch=c(1:5), legend=c("E2","E2:Gen 3:1", "E2:Gen 1:1","E2:Gen 1:3", "Gen"), ncol=1)
dev.off() 

# Quelle est l'EC50 du rayon équipotent en SA et en CA?
# difficile car pas même pente
 # 0.005172612 
 # 0.01594753
modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 7)$p # 0.03222121
modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm, 8)$p # 0.0500857
model_comp(res_E2_Gen_gm_fit_Test2_min, res_E2_Gen_gm_fit_Test2_min_idslopes, 6,5,N_2)$p # 0.01877435
model_comp(res_E2_Gen_gm_fit_SA_Test2_min_idslopes, res_E2_Gen_gm_fit_Test2_min_idslopes, 6,5,N_2)$p #  0.02967533
model_comp(res_E2_Gen_gm_fit_DL_Test2_min_idslopes, res_E2_Gen_gm_fit_SA_Test2_min_idslopes, 7,6,N_2)$p #  0.1478093
model_comp(res_E2_Gen_gm_fit_DR_Test2_min_idslopes, res_E2_Gen_gm_fit_SA_Test2_min_idslopes, 7,6,N_2)$p #  0.2788839
model_comp(res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, res_E2_Gen_gm_fit_Test2_min, 7,6,N_2)$p #  0.04422573
model_comp(res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 8,7,N_2)$p #   0.08037944
model_comp(res_E2_Gen_gm_fit_modified_DR_Test2_min_nlm, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 8,7,N_2)$p #   0.5745772

model_comp(res_E2_Gen_gm_fit_SA_Test2_min_nlm, res_E2_Gen_gm_fit_Test2_min, 7,6,N_2)$p #  0.08818014
model_comp(res_E2_Gen_gm_fit_DL_Test2_min_newDL_nlm, res_E2_Gen_gm_fit_SA_Test2_min_nlm, 8,7,N_2)$p #   0.9527695
model_comp(res_E2_Gen_gm_fit_DR_Test2_min_nlm, res_E2_Gen_gm_fit_SA_Test2_min_nlm, 8,7,N_2)$p #    0.2012435


write.table(cbind(t(data.frame(Anova=c(summary(res_aov_ZGM_E2_Gen_Test2)[[1]][2,2], NA, NA), 
                               CA=c(res_E2_Gen_gm_fit_Test2_min$RSS, NA, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_Test2_min, 6)$p), CA_idslopes=c(res_E2_Gen_gm_fit_Test2_min_idslopes$RSS, model_comp(res_E2_Gen_gm_fit_Test2_min, res_E2_Gen_gm_fit_Test2_min_idslopes, 6,5,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_Test2_min_idslopes, 5)$p), 
                               J_SA_idslopes=c(res_E2_Gen_gm_fit_SA_Test2_min_idslopes$RSS, model_comp(res_E2_Gen_gm_fit_SA_Test2_min_idslopes, res_E2_Gen_gm_fit_Test2_min_idslopes, 6,5,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_SA_Test2_min_idslopes, 6)$p), J_DR_idslopes=c(res_E2_Gen_gm_fit_DR_Test2_min_idslopes$RSS, model_comp(res_E2_Gen_gm_fit_DR_Test2_min_idslopes, res_E2_Gen_gm_fit_SA_Test2_min_idslopes, 7,6,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_DR_Test2_min_idslopes, 8)$p), J_DL_idslopes=c(res_E2_Gen_gm_fit_DL_Test2_min_idslopes$RSS, model_comp(res_E2_Gen_gm_fit_DL_Test2_min_idslopes, res_E2_Gen_gm_fit_SA_Test2_min_idslopes, 7,6,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_DL_Test2_min_idslopes, 8)$p), 
                               J_SA=c(res_E2_Gen_gm_fit_SA_Test2_min_nlm$RSS, model_comp(res_E2_Gen_gm_fit_SA_Test2_min_nlm, res_E2_Gen_gm_fit_Test2_min, 7,6,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_SA_Test2_min_nlm, 7)$p), J_DR=c(res_E2_Gen_gm_fit_DR_Test2_min_nlm$RSS, model_comp(res_E2_Gen_gm_fit_DR_Test2_min_nlm, res_E2_Gen_gm_fit_SA_Test2_min_nlm, 8,7,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_DR_Test2_min_nlm, 8)$p), J_DL=c(res_E2_Gen_gm_fit_DL_Test2_min_newDL_nlm$RSS, model_comp(res_E2_Gen_gm_fit_DL_Test2_min_newDL_nlm, res_E2_Gen_gm_fit_SA_Test2_min_nlm, 8,7,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_DL_Test2_min_newDL_nlm, 8)$p), 
                       J_mod_SA=c(res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm$RSS, model_comp(res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, res_E2_Gen_gm_fit_Test2_min, 7,6,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 7)$p), 
                       J_mod_DR=c(res_E2_Gen_gm_fit_modified_DR_Test2_min_nlm$RSS, model_comp(res_E2_Gen_gm_fit_modified_DR_Test2_min_nlm, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 8,7,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_modified_DR_Test2_min_nlm, 8)$p), J_mod_DL=c(res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm$RSS, model_comp(res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm, res_E2_Gen_gm_fit_modified_SA_Test2_min_nlm, 8,7,N_2)$p, modelFit_CA(res_aov_ZGM_E2_Gen_Test2, res_E2_Gen_gm_fit_modified_DL_Test2_min_newDL_nlm, 8)$p)))), 
                       
                       "res_model_E2_Gen_gm_Test2_min.txt", sep="\t")

exp(1.44*0.25)




ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2<-data.frame(I=log10(ZGM_mixture_E2_Gen_gm_relative[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2"),]$I), E2=ZGM_mixture_E2_Gen_gm_relative$E2[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")], Gen=ZGM_mixture_E2_Gen_gm_relative$Genistein[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")], dose=ZGM_mixture_E2_Gen_gm_relative$E2[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")]+ZGM_mixture_E2_Gen_gm_relative$Genistein[which(ZGM_mixture_E2_Gen_gm_relative$essai=="E2_Gen_2")], pct=NA)
ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2$pct<-signif(ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2$Gen/(ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2$E2+ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2$Gen)*100, 5)
ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2$pct[which(is.na(ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2$pct))]<-999



res_ZGM_mixture_E2_Gen_gm_Test2_min <- drm(I ~ dose, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4())  # CA. 
modelFit(res_ZGM_mixture_E2_Gen_gm_Test2_min) #  0.0000 still not acceptable increase in residuals, even though the number of parameters saved is large.


res_ZGM_mixture_E2_Gen_gm_free_max_EC_Test2_min <- drm(I ~ dose, pct, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4(), pmodels = list(~1,~1, ~factor(pct), ~factor(pct) - 1))  # variable ec50 and max for each ray.
modelFit(res_ZGM_mixture_E2_Gen_gm_free_max_EC_Test2_min) # drc model is not quite acceptable when max and EC50 are different for each ray. 0.0217

res_ZGM_mixture_E2_Gen_gm_free_max_EC_min_Test2_min <- drm(I ~ dose, pct, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4(), pmodels = list(~1, ~factor(pct), ~factor(pct), ~factor(pct) - 1))  # variable ec50 and min and maxfor each ray.
# I can see a logic for the max (higher on rays), and on the EC50 which means the my meanEC50 are not correct for this dataset.
modelFit(res_ZGM_mixture_E2_Gen_gm_free_max_EC_min_Test2_min) #  drc model is acceptable when min and EC50 and max are different for each ray! ############### # p value=0.1870

isobole(res_ZGM_mixture_E2_Gen_gm_free_max_EC_min_Test2_min, ylab="E2", xlab="Gen", ylim=c(0,0.0006), xlim=c(0,1.3)) 

res_ZGM_mixture_E2_Gen_gm_free_min_EC_Test2_min <- drm(I ~ dose, pct, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4(), pmodels = list(~1, ~factor(pct), ~1, ~factor(pct) - 1))  # variable min and ec50 for each ray.
modelFit(res_ZGM_mixture_E2_Gen_gm_free_min_EC_Test2_min) # p value=0.1024 drc model is acceptable when min and EC50  are different for each ray.
isobole(res_ZGM_mixture_E2_Gen_gm_free_min_EC_Test2_min, ylab="E2", xlab="Genistein", xlim=c(0,1.5), ylim=c(0,0.0006)) # Looks like antagonism
res_ZGM_mixture_E2_Gen_gm_free_slopes_Test2_min <- drm(I ~ dose, pct, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4(), pmodels = list(~factor(pct)-1, ~1, ~1, ~1))  # variable slope for each ray.
modelFit(res_ZGM_mixture_E2_Gen_gm_free_slopes_Test2_min) #  0.0000 better stay with anova

res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_Test2_min <- drm(I ~ dose, pct, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4(), pmodels = list(~factor(pct), ~1, ~1, ~factor(pct) - 1))  # variable slope and ec50 for each ray.
modelFit(res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_Test2_min) ##### p value=0.0907 drc model is acceptable when slopes and EC50  are different for each ray.
res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_min_Test2_min <- drm(I ~ dose, pct, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4(), pmodels = list(~factor(pct), ~factor(pct), ~1, ~factor(pct) - 1))  # variable slope and ec50 and min for each ray.
modelFit(res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_min_Test2_min) ##### p value= 0.3390 drc model is acceptable when slopes and EC50 an min are different 

res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_max_Test2_min <- drm(I ~ dose, pct, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4(), pmodels = list(~factor(pct), ~1, ~factor(pct), ~factor(pct) - 1))  # variable slopes and EC50 and max for each ray.
modelFit(res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_max_Test2_min) # p value=0.0283 drc model is not acceptable when slopes and EC50 and max  are different for each ray. (!not like arithm mean normalisation)
isobole(res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_max_Test2_min, ylab="E2", xlab="Genistein", xlim=c(0,1.5), ylim=c(0,0.0006)) # Looks like antagonism


res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min <- drm(I ~ dose, pct, data = ZGM_mixture_E2_Gen_gm_relative_for_drm_Test2, fct = LL.4(), pmodels = list(~1, ~1, ~1, ~factor(pct)-1))  # variable ec50 for each ray.
modelFit(res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min) # p-value= 0.0122 not quite acceptable, anova still better

anova(res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_Test2_min, res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min)# 0.0123 il vaut mieux mettre des pentes différentes
anova(res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_max_Test2_min, res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min)# non pas des max et des pentes
anova(res_ZGM_mixture_E2_Gen_gm_free_min_EC_Test2_min, res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min)# 0.0100 oui, il vaut mieux mettre des min différents
anova(res_ZGM_mixture_E2_Gen_gm_free_max_EC_Test2_min, res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min)# non
anova(res_ZGM_mixture_E2_Gen_gm_free_max_EC_min_Test2_min, res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min)# 0.0085 oui des max et des min différents ça vaut le coup

anova(res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_min_Test2_min, res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min)# 0.0033 oui des pentes et des min différents ça vaut vraiment le coup
anova(res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_min_Test2_min, res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_Test2_min)# 0.0358 oui le min ne vaut pas le coupen plus de la pente.
## Fitting the concentration addition model
res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min.ca <- mixture(res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min, model = "CA", start=c(-2.746,  -0.13, 1, 0.0003875 ,  0.0002619)) # CA with pmodels: ~1, ~1, ~1, ~I(1/(pct/100)) - 1, ~I(1/(1 - pct/100)) - 1
# min sets to -0.27
modelFit(res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min.ca) #p.value= 0.0050 Better use anova than CA with same slopes and max and min
# I should manage to change the drc function to accomodate different slopes in CA.



## Comparing to model with freely varying e parameter
anova(res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min.ca, res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min) # 0.0620. Better have CA (fewer param) than freely varying EC50.###good!
anova(res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min.ca, res_ZGM_mixture_E2_Gen_gm_free_slopes_Test2_min) #1. Better have CA 
anova(res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min.ca, res_ZGM_mixture_E2_Gen_gm_free_slopes_EC_Test2_min) # 0.0053. Better have free EC and slope 
## Plotting isobole based on concentration addition
isobole(res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min, res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min.ca, exchange = 5000, ylab="Gen", xlab="E2") 


jpeg("Zebra_GM/E2_Gen_gm/ZGM_EC_isobole_EC50_Essai2.jpg", height=8,width=8, unit="cm",res=300, pointsize=10)
par(mar=c(4,4,2,0.5), cex.axis=1.2, cex.lab=1.2, cex.main=1.5, mgp=c(2.5,1.2,0))
isobole(res_ZGM_mixture_E2_Gen_gm_free_EC_Test2_min, ylab="E2 (nM)", xlab="Genistein (nM)", axes=F) # antagonism Doesn't quite fit though OK à 1%
box()
axis(1, at=seq(0,1, by=0.2), labels=seq(0,1, by=0.2)*1000)
axis(2, at=seq(0,0.0005, by=0.0001), labels=seq(0,0.0005, by=0.0001)*1000)
dev.off()

